• 300. Longest Increasing Subsequence


    Problem statement

    Given an unsorted array of integers, find the length of longest increasing subsequence.

    For example,
    Given [10, 9, 2, 5, 3, 7, 101, 18],
    The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

    Your algorithm should run in O(n2) complexity.

    Follow up: Could you improve it to O(n log n) time complexity?

    Solution

    This is one sequence DP problem. The dp array is one dimension. dp[i] means first i chars in the given string. The return value is not dp[n], it is one max value among dp[0 ... n - 1].

    dp[i] = max(dp[i], dp[j] + 1) if nums[i] == nums[j], meanwhile, update the max LIS.

    Time complexity is O(n * n).

    class Solution {
    public:
        int lengthOfLIS(vector<int>& nums) {
            int max_lis = 0;
            int size = nums.size();
            vector<int> lis(size, 1);
            for(int i = 0; i < size; i++){
                for(int j = 0; j < i; j++){
                    if(nums[i] > nums[j]){
                        lis[i] = max(lis[i], lis[j] + 1);
                    }
                }
                max_lis = max(max_lis, lis[i]);
            }
            return max_lis;
        }
    };
  • 相关阅读:
    Good Substrings CodeForces
    Watto and Mechanism Codeforces Round #291 (Div. 2)
    Codeforces Round #487 (Div. 2) A Mist of Florescence (暴力构造)
    Oulipo HDU
    POJ
    求值2 组合数公式题目
    URAL
    SCU
    【转】phpcms授课学习
    WordPress文章浏览历史插件
  • 原文地址:https://www.cnblogs.com/wdw828/p/6858867.html
Copyright © 2020-2023  润新知